package org.fuseri.moduleexercise.answer;

import org.fuseri.model.dto.exercise.AnswerCreateDto;
import org.fuseri.model.dto.exercise.AnswerDto;
import org.fuseri.model.dto.exercise.AnswerInQuestionCreateDto;
import org.fuseri.moduleexercise.common.DomainMapper;
import org.mapstruct.Mapper;

/**
 * Mapper between Answers and their corresponding DTOs
 */
@Mapper
public interface AnswerMapper extends DomainMapper<Answer, AnswerDto> {

    /**
     * Convert DTO of type AnswerCreateDto to Answer
     *
     * @param dto DTO to be converted
     * @return corresponding Answer entity created from DTO
     */
    Answer fromCreateDto(AnswerCreateDto dto);

    /**
     * Convert DTO of type AnswerInQuestionCreateDto to Answer
     * @param dto DTO to be converted
     * @return corresponding Answer entity created from DTO
     */
    Answer fromCreateDto(AnswerInQuestionCreateDto dto);
}
