package org.fuseri.moduleexercise.question;

import jakarta.persistence.*;
import lombok.*;
import org.fuseri.moduleexercise.answer.Answer;
import org.fuseri.moduleexercise.common.DomainObject;
import org.fuseri.moduleexercise.exercise.Exercise;

import java.util.HashSet;
import java.util.Set;

/**
 * Represent Question entity
 */
@Getter
@Setter
@NoArgsConstructor
@AllArgsConstructor
@Builder
@Entity
@Table(name = "question")
public class Question extends DomainObject {

    private String text;

    @OneToMany(mappedBy = "question", cascade = CascadeType.ALL, orphanRemoval = true)
    private Set<Answer> answers = new HashSet<>();

    @ManyToOne
    @JoinColumn(name = "exercise_id", nullable=false)
    private Exercise exercise;

}
